#include "avisynth2.h"

DWORD WINAPI TwoCleanYV12_smp(void * my_data_args);

int __stdcall ppixels_y(int	Thresh,
							unsigned char	*srcp,
							unsigned char	*dstp,
							int				fDebugNoise,
							int				radiusX,
							int				radiusY,
							int				multfact,
							int				pitchm,
							int				width,
							int				height,
							int				src_modulo,
							int				dst_modulo
						 );

int __stdcall ppixels_c(int	Thresh,
							unsigned char	*srcp,
							unsigned char	*dstp,
							int				fDebugNoise,
							int				radiusX,
							int				radiusY,
							int				multfact,
							int				pitchm,
							int				width,
							int				height,
							int				src_modulo,
							int				dst_modulo
						 );

int __stdcall ppixels_y_sse2(int	Thresh,
							unsigned char	*srcp,
							unsigned char	*dstp,
							int				fDebugNoise,
							int				radiusX,
							int				radiusY,
							int				multfact,
							int				pitchm,
							int				width,
							int				height,
							int				src_modulo,
							int				dst_modulo
						 );

#define Init_Pixel(srcp,count_lo,count_hi,sum_lo,sum_hi,cpixelsptr) \
	__asm	mov			eax, count_lo		\
	__asm	movq		[eax], mm5			\
	__asm	mov			eax, count_hi		\
	__asm	movq		[eax], mm5			\
	__asm	mov			eax, sum_lo			\
	__asm	movq		[eax], mm5			\
	__asm	mov			eax, sum_hi			\
	__asm	movq		[eax], mm5			\
	__asm	mov			esi, srcp			\
	__asm	movq		mm0, [esi]			\

#define Read_RoundPixel_LeftBound(posx) \
	__asm	mov			eax, cptr					\
	__asm	movq		mm1, [eax]					\
	__asm	psllq		mm1, -(posx*8)				\
	__asm	movq		mm3, mm1					\
	__asm	movq		mm4, mm0					\
	__asm	pmaxub		mm3, mm4					\
	__asm	pminub		mm4, mm1					\
	__asm	psubusb		mm3, mm4					\
	__asm	movq		mm4, mm3					\
	__asm	movq		mm2, bytemask				\
	__asm	pand		mm4, mm2					\
	__asm	pcmpeqb		mm4, mm2					\
	__asm	por			mm3, mm4					\
	__asm	movq		mm2, bytemask2				\
	__asm	pand		mm3, mm2					\
	__asm	movq		mm4, mm7					\
	__asm	pcmpgtb		mm4, mm3					\
	__asm	movq		mm3, mm4					\
	__asm	pand		mm3, mm1					\
	__asm	lea			eax,[Bound_Mask - (posx*8)]	\
	__asm	movq		mm2, [eax]					\
	__asm	pand		mm3, mm2					\
	__asm	pand		mm4, mm2					\

#define Read_RoundPixel_RightBound(posx) \
	__asm	mov			eax, cptr					\
	__asm	movq		mm1, [eax]					\
	__asm	psrlq		mm1, posx*8					\
	__asm	movq		mm3, mm1					\
	__asm	pmaxub		mm3, mm0					\
	__asm	movq		mm4, mm0					\
	__asm	pminub		mm4, mm1					\
	__asm	psubusb		mm3, mm4					\
	__asm	movq		mm4, mm3					\
	__asm	movq		mm2, bytemask				\
	__asm	pand		mm4, mm2					\
	__asm	pcmpeqb		mm4, mm2					\
	__asm	por			mm3, mm4					\
	__asm	movq		mm2, bytemask2				\
	__asm	pand		mm3, mm2					\
	__asm	movq		mm4, mm7					\
	__asm	pcmpgtb		mm4, mm3					\
	__asm	movq		mm3, mm4					\
	__asm	pand		mm3, mm1					\
	__asm	lea			eax,[Bound_Mask+3*8+ posx*8]	\
	__asm	movq		mm2, [eax]					\
	__asm	pand		mm3, mm2					\
	__asm	pand		mm4, mm2					\

#define Read_RoundPixel(posx) \
	__asm	mov			eax, cptr					\
	__asm	add			eax, posx					\
	__asm	movq		mm1, [eax]					\
	__asm	movq		mm3, mm1					\
	__asm	pmaxub		mm3, mm0					\
	__asm	movq		mm4, mm0					\
	__asm	pminub		mm4, mm1					\
	__asm	psubusb		mm3, mm4					\
	__asm	movq		mm4, mm3					\
	__asm	movq		mm2, bytemask				\
	__asm	pand		mm4, mm2					\
	__asm	pcmpeqb		mm4, mm2					\
	__asm	por			mm3, mm4					\
	__asm	movq		mm2, bytemask2				\
	__asm	pand		mm3, mm2					\
	__asm	movq		mm4, mm7					\
	__asm	pcmpgtb		mm4, mm3					\
	__asm	movq		mm3, mm4					\
	__asm	pand		mm3, mm1					\

#define Read_RoundPixel_LeftBound_UV(posx) \
	__asm	mov			eax, cptr					\
	__asm	movq		mm1, [eax]					\
	__asm	psllq		mm1, -(posx*8)				\
	__asm	movq		mm3, mm1					\
	__asm	psubsb		mm3, mm0					\
	__asm	movq		mm4, mm6					\
	__asm	pcmpgtb		mm4, mm3					\
	__asm	pcmpgtb		mm3, mm7					\
	__asm	pand		mm3, mm4					\
	__asm	movq		mm4, mm3					\
	__asm	pand		mm3, mm1					\
	__asm	lea			eax,[Bound_Mask - (posx*8)]	\
	__asm	movq		mm2, [eax]					\
	__asm	pand		mm3, mm2					\
	__asm	pand		mm4, mm2					\

#define Read_RoundPixel_RightBound_UV(posx) \
	__asm	mov			eax, cptr					\
	__asm	movq		mm1, [eax]					\
	__asm	psrlq		mm1, posx*8					\
	__asm	movq		mm3, mm1					\
	__asm	psubsb		mm3, mm0					\
	__asm	movq		mm4, mm6					\
	__asm	pcmpgtb		mm4, mm3					\
	__asm	pcmpgtb		mm3, mm7					\
	__asm	pand		mm3, mm4					\
	__asm	movq		mm4, mm3					\
	__asm	pand		mm3, mm1					\
	__asm	lea			eax,[Bound_Mask+3*8+ posx*8]	\
	__asm	movq		mm2, [eax]					\
	__asm	pand		mm3, mm2					\
	__asm	pand		mm4, mm2					\

#define Read_RoundPixel_UV(posx) \
	__asm	mov			eax, cptr					\
	__asm	add			eax, posx					\
	__asm	movq		mm1, [eax]					\
	__asm	movq		mm3, mm1					\
	__asm	psubsb		mm3, mm0					\
	__asm	movq		mm4, mm6					\
	__asm	pcmpgtb		mm4, mm3					\
	__asm	pcmpgtb		mm3, mm7					\
	__asm	pand		mm3, mm4					\
	__asm	movq		mm4, mm3					\
	__asm	pand		mm3, mm1					\

#define Add_Counter() \
	__asm	movq		mm1, mm3			\
	__asm	punpcklbw	mm1, mm5			\
	__asm	mov			eax, sum_lo			\
	__asm	movq		mm2, [eax]			\
	__asm	paddsw		mm1, mm2			\
	__asm	movq		[eax], mm1			\
											\
	__asm	punpckhbw	mm3, mm5			\
	__asm	mov			eax, sum_hi			\
	__asm	movq		mm2, [eax]			\
	__asm	paddsw		mm3, mm2			\
	__asm	movq		[eax], mm3			\
											\
	__asm	movq		mm1, mm4			\
	__asm	punpcklbw	mm1, mm5			\
	__asm	psrlw		mm1, 7				\
	__asm	mov			eax, count_lo		\
	__asm	movq		mm2, [eax]			\
	__asm	paddw		mm1, mm2			\
	__asm	movq		[eax], mm1			\
											\
	__asm	punpckhbw	mm4, mm5			\
	__asm	psrlw		mm4, 7				\
	__asm	mov			eax, count_hi		\
	__asm	movq		mm2, [eax]			\
	__asm	paddw		mm4, mm2			\
	__asm	movq		[eax], mm4			\

#define Store_Pixel() \
	__asm		mov			eax, sum_lo					\
	__asm		mov			ebx, count_lo				\
	__asm		movq		mm3, [eax]					\
	__asm		movq		mm4, [ebx]					\
	__asm		pmulhuw		mm3, mm4					\
	__asm		mov			eax, sum_hi					\
	__asm		mov			ebx, count_hi				\
	__asm		movq		mm2, [eax]					\
	__asm		movq		mm4, [ebx]					\
	__asm		pmulhuw		mm2, mm4					\
	__asm		packuswb	mm3, mm2					\
	__asm		mov			eax, dstp					\
	__asm		movq		[eax], mm3					\
	__asm		emms									\

#define Store_Pixel4() \
	__asm		mov			eax, sum_lo					\
	__asm		mov			ebx, count_lo				\
	__asm		movq		mm3, [eax]					\
	__asm		movq		mm4, [ebx]					\
	__asm		pmulhuw		mm3, mm4					\
	__asm		packuswb	mm3, mm5					\
	__asm		movd		edx, mm3					\
	__asm		mov			eax, dstp					\
	__asm		mov			[eax], edx					\
	__asm		emms									\

#define Store_Pixel2() \
	__asm		mov			eax, sum_lo					\
	__asm		mov			ebx, count_lo				\
	__asm		movq		mm3, [eax]					\
	__asm		movq		mm4, [ebx]					\
	__asm		pmulhuw		mm3, mm4					\
	__asm		packuswb	mm3, mm5					\
	__asm		movd		edx, mm3					\
	__asm		mov			eax, dstp					\
	__asm		mov			[eax], dx					\
	__asm		emms									\


