;  This program is free software; you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation; either version 2 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with this program; if not, write to the Free Software
;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

.686
.mmx
.xmm
.model flat, C

include ppixels.macro
;------------------------------------------------------------------------

LOCVARSZ = 256
WORK				= 0		;qword * 2	;for debug use

TOTAL_YUV			= 16	;qword
TMPCOUNT			= 24	;qword
CURRENT_YUV_LO		= 32	;qword
CURRENT_YUV_HI		= 40	;qword
WRITE_DATA			= 48	;qword

LOOPX				= 56	;DWORD
LOOPY				= 60	;DWORD
X					= 64	;DWORD
Y					= 68	;DWORD
F_HILO				= 72	;DWORD
F_HILO_2			= 76	;DWORD
STARTP				= 80	;DWORD
TOTALNUMS			= 84	;DWORD
LINENUMS			= 88	;DWORD
START_Y				= 92	;DWORD
ROWCOUNT			= 96	;DWORD
OUTP				= 100	;DWORD

OLD_STACK_PTR		= 104	;DWORD
WORKPTR				= 108	;DWORD	;for debug use

;--- parameter copy ---
copy_parm_block		= 128
threshold_YUV$		= copy_parm_block + 0	;qword
srcp$				= copy_parm_block + 8
dstp$				= copy_parm_block + 12
YUVsrcp$			= copy_parm_block + 16
YUVdstp$			= copy_parm_block + 20
fDebugNoise$		= copy_parm_block + 24
radiusX$			= copy_parm_block + 28
radiusY$			= copy_parm_block + 32
multfact$			= copy_parm_block + 36
pitchm$				= copy_parm_block + 40
width$				= copy_parm_block + 44
height$				= copy_parm_block + 48
src_modulo$			= copy_parm_block + 52
dst_modulo$			= copy_parm_block + 56

;--- parameter ---
REGSTACK = 24
parm_block			= REGSTACK + 4
_threshold_YUV$		= parm_block + 0
_srcp$				= parm_block + 8
_dstp$				= parm_block + 12
_YUVsrcp$			= parm_block + 16
_YUVdstp$			= parm_block + 20
_fDebugNoise$		= parm_block + 24
_radiusX$			= parm_block + 28
_radiusY$			= parm_block + 32
_multfact$			= parm_block + 36
_pitchm$			= parm_block + 40
_width$				= parm_block + 44
_height$			= parm_block + 48
_src_modulo$		= parm_block + 52
_dst_modulo$		= parm_block + 56

PARM_LENGTH	= 60

public ppixels@60

_TEXT64 segment


;EXTRN debugblock:BYTE
EXTRN divtable:BYTE
EXTRN n_by_2:BYTE

UV_MASK			dq	 00000000ff00ff00h
UVY0_MASK		dq	 00000000ff00ffffh
UVY1_MASK		dq	 00000000ffffff00h
Y0_MASK			dq	 00000000000000ffh
Y1_MASK			dq	 0000000000ff0000h
UVUVY0_MASK		dq	0ff00ff00ff00ffffh
UVY1UVY0_MASK	dq	0ffffff00ff00ffffh
HI_Y1_MASK		dq	 00ff000000000000h
WHITE_PIXEL		dq	 0000000080eb80ebh		;(128,235,128,235)
WHITE_PIXEL_LO	dq	 00000000800080ebh		;(128,  0,128,235)
WHITE_PIXEL_HI	dq	 0000000080eb8000h		;(128,235,128,  0)
BLACK_PIXEL		dq	 0000000080008000h		;(128,  0,128,  0)
ONE				dq	 0000000000000001h
WORD_Y0_MASK	dq	 000000000000ffffh
WORD_Y1_MASK	dq	 0000ffff00000000h
WORD_Y1Y0_MASK	dq	 0000ffff0000ffffh				;*** v07
WORD_UV_MASK	dq	0ffff0000ffff0000h
WORD_UVY0_MASK	dq	0ffff0000ffffffffh
WORD_UVY1_MASK	dq	0ffffffffffff0000h
ROUND_TWO		dq	 0001000100010001h
DIV_TWO			dq	 8000800080008000h
WORD_WHITE_PIXEL		dq	 008000eb008000ebh		;(128,235,128,235) *** v07
WORD_WHITE_PIXEL_LO		dq	 00800000008000ebh		;(128,  0,128,235) *** v07
WORD_WHITE_PIXEL_HI		dq	 008000eb00800000h		;(128,235,128,  0) *** v07
WORD_BLACK_PIXEL		dq	 0080000000800000h		;(128,  0,128,  0) *** v07

ppixels@60 PROC NEAR

align 16
;-------------------------------------------------------------------
		push		ebp
		push		esi
		push		edi
		push		ebx
		push		ecx
		push		edx
		mov			ebp,esp
		and			esp,-16				;stack boundary align 128bit(16bytes) (for sse2)
		sub			esp,LOCVARSZ
		
		;-------------- parameter copy & free ebp reg. (for debug use) ----------
		mov			[OLD_STACK_PTR+esp],ebp
		lea			esi,[parm_block+ebp]
		lea			edi,[copy_parm_block+esp]
		mov			ecx,PARM_LENGTH
		rep movsb

;		lea			eax,[debugblock]	;debug massege table 
;		mov			[WORKPTR+esp],eax
;		mov			ebp,eax
		;------------------------------------------------------------------------

		pxor		mm7,mm7						;allways mm7=0
		movq		mm3,mm7						;output data clear

		m_convertYUY2toYUV		srcp$+esp , YUVsrcp$+esp	;unpack YUY2

		mov			ecx,[YUVsrcp$+esp]
		mov			[srcp$+esp],ecx
		mov			[START_Y+esp],ecx

		mov			ecx,[YUVdstp$+esp]
		mov			[OUTP+esp],ecx
;		shl			DWORD PTR [pitchm$+esp],1

		mov			ebx,[height$+esp]
		xor			eax,eax
		movq		mm6,[threshold_YUV$+esp]
		mov			[Y+esp],eax
		inc			ebx							;(height-1)+1
		mov			[LOOPY+esp],ebx

		mov			eax,[radiusX$+esp]
		jmp			radiusX_jmptbl[eax*4]

;-----------------------
NPVOID	TYPEDEF		NEAR PTR
radiusX_jmptbl		NPVOID radius0, radius1, radius2, radius3
;-----------------------

;====================================================================================
radius2:
;====================================================================================
align 16
radius2_loopY_start:
		mov			eax,[width$+esp]
		sub			eax,4				;subtract both left and right 2 pixels
		shr			eax,1				;loopX / 2
		mov			[LOOPX+esp],eax

align 16
radius2_loopX_start:

;*****************************
;* case X=0                  *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2low
		mov			[START_Y+esp],eax		;START_Y = Current

		mov			ebx,[radiusY$+esp]		;
		mov			edi,ebx
		shl			edi,1
		mov			eax,[Y+esp]
		mov			edx,eax
		mov			esi,eax
		and			esi,00000001y
		mov			ecx,[multfact$+esp]
		shr			ecx,1
		cmovnz		ebx,edi					;if(_multifact==2) radiusY<<=1
		sub			eax,ebx					;y-radiusY
		cmovs		eax,esi					;lowy=y-radiusY,if(y-radiusY<0),then (y&1)
		mov			esi,eax					;lowy
		mov			eax,[height$+esp]		;hight-1
		mov			edi,eax
		mov			ecx,edx					;y
		add			ecx,ebx					;y+radiusy
		sub			eax,ecx					;(hight-1)-(y+radiusy)
		cmovb		ecx,edi					;highy=y+radiusy, if(y+radiusY>hight-1),then hight-1			
		sub			ecx,esi					;
		mov			eax,ecx
		shr			eax,1
		mov			edi,[multfact$+esp]
		shr			edi,1
		cmovnz		ecx,eax					;if(multifact==2) count/2
		inc			ecx						;loopY counter=highY-lowY+1
		mov			[LINENUMS+esp],ecx
		mov			eax,esi
		sub			eax,edx					;lowy-y
		mov			ebx,eax
		shr			ebx,1
		or			edi,edi					;if (multfact/2==0) (lowy-y)/2
		cmovnz		eax,ebx
		mul			DWORD PTR [pitchm$+esp]
		add			[START_Y+esp],eax

		mov			eax,ecx					;toalnums = loopY counter * 3
		shl			eax,1
		add			eax,ecx
		mov			[TOTALNUMS+esp],eax
		
		mov			eax,[START_Y+esp]
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)

align 16
radius2_0_loop:
		movq		mm0,[eax]
		m_cmp_low_high
		movq		mm0,[eax+8]
		m_cmp_low
		dec			ecx
		jle			radius2_0_store_data
		add			eax,esi
		jmp			radius2_0_loop

radius2_0_store_data:
		prefetchnta	[eax+16]
		m_store_data_even

;*****************************
;* case X=1                  *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2high

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		mov			[TOTALNUMS+esp],eax
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]

align 16
radius2_1_loop:
		movq		mm0,[eax]
		m_cmp_low_high
		movq		mm0,[eax+8]
		m_cmp_low
		dec			ecx
		jle			radius2_1_store_data
		add			eax,esi
		jmp			radius2_1_loop

radius2_1_store_data:
		prefetchnta	[eax+16]
		m_store_data_odd

;*****************************
;* case X=2 to width-3       *
;*****************************

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		add			eax,ecx				;total=loopY*5			
		mov			[TOTALNUMS+esp],eax

align 16
radius2_full_loopX:
		; in
		;		mm6 = threshold_YUV
		;		mm7 = allways zero
		;		mm4 = CURRENT_YUV
		; work: edx = counter, mm5 = sum(YUV), mm3 = store tmp write data, ebx=temp

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2low

		xor			edx,edx				;counter = 0
		mov			ecx,[LINENUMS+esp]
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius2_full_low_loop1_even:
		movq		mm0,[eax-8]		;pixel_X=(currentX-2),(currentX-1)
		m_cmp_low_high
		movq		mm0,[eax+0]		;pixel_X=(currentX),(currentX+1)
		m_cmp_low_high
		movq		mm0,[eax+8]		;pixel_X=(currentX+2)
		m_cmp_low
		dec			ecx
		jle			radius2_make_store_data_even
		add			eax,esi
		jmp			radius2_full_low_loop1_even

radius2_make_store_data_even:

		prefetchnta	[eax+16]
		m_store_data_even

;+++++++++ odd +++++++
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)
		m_get_yuy2high

		xor			edx,edx				;counter = 0
		mov			ecx,[LINENUMS+esp]
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius2_full_high_loop1_odd:
		movq		mm0,[eax-8]		;pixel_X=(currentX-2)
		m_cmp_high
		movq		mm0,[eax+0]		;pixel_X=(currentX-1),(currentX+0)
		m_cmp_low_high
		movq		mm0,[eax+8]		;pixel_X=(currentX+1),(currentX+2)
		m_cmp_low_high
		dec			ecx
		jle			radius2_make_store_data_odd
		add			eax,esi
		jmp			radius2_full_high_loop1_odd
	
radius2_make_store_data_odd:

		prefetchnta	[eax+16]
		m_store_data_odd

		dec			DWORD PTR [LOOPX+esp]
		jnz			radius2_full_loopX


;*****************************
;* case X = width-2          *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2low

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		mov			[TOTALNUMS+esp],eax
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius2_w2_border:
		movq		mm0,[eax-8]
		m_cmp_low_high
		movq		mm0,[eax]
		m_cmp_low_high
		dec			ecx
		jle			radius2_w2_store_data
		add			eax,esi
		jmp			radius2_w2_border

radius2_w2_store_data:
		prefetchnta	[eax+8]
		m_store_data_even

;*****************************
;* case X = width-1          *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2high

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		add			eax,eax
		add			eax,ecx
		mov			[TOTALNUMS+esp],eax	;total = loopY count * 3
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius2_w1_border:
		movq		mm0,[eax-8]
		m_cmp_high
		movq		mm0,[eax]
		m_cmp_low_high
		dec			ecx
		jle			radius2_w1_store_data
		add			eax,esi
		jmp			radius2_w1_border

radius2_w1_store_data:
		prefetchnta	[eax+8]
		m_store_data_odd

		mov			edi,[dst_modulo$+esp]
		add			[dstp$+esp],edi

;*****************************
;* while end loopY           *
;*****************************
radius2_loopY_end:

		inc			DWORD PTR [Y+esp]
		dec			DWORD PTR [LOOPY+esp]
		jnz			radius2_loopY_start

mov eax,[dst_modulo$+esp]

exit:
		emms
		
		mov			ebp,[OLD_STACK_PTR+esp]
;;;		add			esp,LOCVARSZ
		mov			esp,ebp
		pop			edx
		pop			ecx
		pop			ebx
		pop			edi
		pop			esi
		pop			ebp
		ret        PARM_LENGTH


;======================================================================================
radius0:
;======================================================================================
align 16
radius0_loopY_start:
		mov			eax,[width$+esp]
		shr			eax,1				;loopX / 2
		mov			[LOOPX+esp],eax

align 16
radius0_loopX_start:

		mov			eax,[srcp$+esp]
		mov			[START_Y+esp],eax

		mov			ebx,[radiusY$+esp]		;
		mov			edi,ebx
		shl			edi,1
		mov			eax,[Y+esp]
		mov			edx,eax
		mov			esi,eax
		and			esi,00000001y
		mov			ecx,[multfact$+esp]
		shr			ecx,1
		cmovnz		ebx,edi					;if(_multifact==2) radiusY<<=1
		sub			eax,ebx					;y-radiusY
		cmovs		eax,esi					;lowy=y-radiusY,if(y-radiusY<0),then (y&1)
		mov			esi,eax					;lowy
		mov			eax,[height$+esp]		;hight-1
		mov			edi,eax
		mov			ecx,edx					;y
		add			ecx,ebx					;y+radiusy
		sub			eax,ecx					;(hight-1)-(y+radiusy)
		cmovb		ecx,edi					;highy=y+radiusy, if(y+radiusY>hight-1),then hight-1			
		sub			ecx,esi					;
		mov			eax,ecx
		shr			eax,1
		mov			edi,[multfact$+esp]
		shr			edi,1
		cmovnz		ecx,eax					;if(multifact==2) count/2
		inc			ecx						;loopY counter=highY-lowY+1
		mov			[LINENUMS+esp],ecx
		mov			[TOTALNUMS+esp],ecx
		mov			eax,esi
		sub			eax,edx					;lowy-y
		mov			ebx,eax
		shr			ebx,1
		or			edi,edi					;if (multfact/2==0) (lowy-y)/2
		cmovnz		eax,ebx
		mul			DWORD PTR [pitchm$+esp]
		add			[START_Y+esp],eax

;*****************************
;* case X=0 to width-1       *
;*****************************
align 16
radius0_loopX:
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)
		mov			ecx,[LINENUMS+esp]

		m_get_yuy2low

		; in
		;       ecx = numbers of lines
		;		mm6 = threshold_YUV
		;		mm7 = allways zero
		;		mm5 = 0 (sum)
		;		mm4 = CURRENT_YUV

		; work: edx = counter, ebx=temp

		xor			edx,edx				;counter = 0
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius0_low_loop1_even:
		movq		mm0,[eax]		;pixel_X=(currentX)
		m_cmp_low
		add			eax,esi
		loop		radius0_low_loop1_even

radius0_make_store_data_even:
		prefetchnta	[eax+8]
		m_store_data_even


;+++++++++ odd +++++++
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)
		mov			eax,[srcp$+esp]		;current pixel address
		mov			ecx,[LINENUMS+esp]

		m_get_yuy2high

		; in
		;       ecx = numbers of lines
		;		mm6 = threshold_YUV
		;		mm7 = allways zero
		;		mm5 = 0 (sum)
		;		mm4 = CURRENT_YUV

		; work: edx = counter, ebx=temp

		xor			edx,edx				;counter = 0
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius0_high_loop1_odd:
		movq		mm0,[eax]		;pixel_X=(currentX)
		m_cmp_high
		add			eax,esi
		loop		radius0_high_loop1_odd
	
radius0_make_store_data_odd:
		prefetchnta	[eax+8]
		m_store_data_odd

		dec			DWORD PTR [LOOPX+esp]
		jnz			radius0_loopX

		mov			edi,[dst_modulo$+esp]
		add			[dstp$+esp],edi

;*****************************
;* while end loopY           *
;*****************************
radius0_loopY_end:
		inc			DWORD PTR [Y+esp]
		dec			DWORD PTR [LOOPY+esp]
		jnz			radius0_loopY_start
		jmp			exit



;--------------------------------------------------------------------------------------
radius1:
;--------------------------------------------------------------------------------------
align 16
radius1_loopY_start:
		mov			eax,[width$+esp]
		sub			eax,2				;subtract both left and right 1 pixels
		shr			eax,1				;loopX / 2
		mov			[LOOPX+esp],eax

align 16
radius1_loopX_start:

;*****************************
;* case X=0                  *
;*****************************
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2low
		mov			[START_Y+esp],eax		;START_Y = Current

		mov			ebx,[radiusY$+esp]		;
		mov			edi,ebx
		shl			edi,1
		mov			eax,[Y+esp]
		mov			edx,eax
		mov			esi,eax
		and			esi,00000001y
		mov			ecx,[multfact$+esp]
		shr			ecx,1
		cmovnz		ebx,edi					;if(_multifact==2) radiusY<<=1
		sub			eax,ebx					;y-radiusY
		cmovs		eax,esi					;lowy=y-radiusY,if(y-radiusY<0),then (y&1)
		mov			esi,eax					;lowy
		mov			eax,[height$+esp]		;hight-1
		mov			edi,eax
		mov			ecx,edx					;y
		add			ecx,ebx					;y+radiusy
		sub			eax,ecx					;(hight-1)-(y+radiusy)
		cmovb		ecx,edi					;highy=y+radiusy, if(y+radiusY>hight-1),then hight-1			
		sub			ecx,esi					;
		mov			eax,ecx
		shr			eax,1
		mov			edi,[multfact$+esp]
		shr			edi,1
		cmovnz		ecx,eax					;if(multifact==2) count/2
		inc			ecx						;loopY counter=highY-lowY+1
		mov			[LINENUMS+esp],ecx
		mov			eax,esi
		sub			eax,edx					;lowy-y
		mov			ebx,eax
		shr			ebx,1
		or			edi,edi					;if (multfact/2==0) (lowy-y)/2
		cmovnz		eax,ebx
		mul			DWORD PTR [pitchm$+esp]
		add			[START_Y+esp],eax

		mov			eax,ecx					;toalnums = loopY counter * 2
		shl			eax,1
		mov			[TOTALNUMS+esp],eax
		
		mov			eax,[START_Y+esp]
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)

align 16
radius1_0_loop:
		movq		mm0,[eax]
		m_cmp_low_high
		dec			ecx
		jle			radius1_0_store_data
		add			eax,esi
		jmp			radius1_0_loop

radius1_0_store_data:
		m_store_data_even

;*****************************
;* case X=1 to width-2       *
;*****************************

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,1
		add			eax,ecx				;total=loopY*3
		mov			[TOTALNUMS+esp],eax

align 16
radius1_full_loopX:
;+++++++++ odd +++++++
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2high

		xor			edx,edx				;counter = 0
		mov			ecx,[LINENUMS+esp]
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius1_full_high_loop1_odd:
		movq		mm0,[eax+0]		;pixel_X=(currentX-1),(currentX+0)
		m_cmp_low_high
		movq		mm0,[eax+8]		;pixel_X=(currentX+1)
		m_cmp_low
		dec			ecx
		jle			radius1_make_store_data_odd
		add			eax,esi
		jmp			radius1_full_high_loop1_odd
	
radius1_make_store_data_odd:
		prefetchnta	[eax+16]
		m_store_data_odd


;+++++++++ even +++++++
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)
		mov			ecx,[LINENUMS+esp]

		m_get_yuy2low

		xor			edx,edx				;counter = 0
		mov			ecx,[LINENUMS+esp]
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius1_full_low_loop1_even:
		movq		mm0,[eax-8]		;pixel_X=(currentX-1)
		m_cmp_high
		movq		mm0,[eax+0]		;pixel_X=(currentX+0),(currentX+1)
		m_cmp_low_high
		dec			ecx
		jle			radius1_make_store_data_even
		add			eax,esi
		jmp			radius1_full_low_loop1_even

radius1_make_store_data_even:
		prefetchnta	[eax+8]
		m_store_data_even

		dec			DWORD PTR [LOOPX+esp]
		jnz			radius1_full_loopX

;*****************************
;* case X = width-1          *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2high


radius1_w1_calc_lines:
		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		add			eax,eax
		mov			[TOTALNUMS+esp],eax	;total = loopY count * 2
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius1_w1_border:
		movq		mm0,[eax+0]			;(current-1),(current)
		m_cmp_low_high
		dec			ecx
		jle			radius1_w1_store_data
		add			eax,esi
		jmp			radius1_w1_border

radius1_w1_store_data:
		m_store_data_odd

		mov			edi,[dst_modulo$+esp]
		add			[dstp$+esp],edi

;*****************************
;* while end loopY           *
;*****************************
radius1_loopY_end:

		inc			DWORD PTR [Y+esp]
		dec			DWORD PTR [LOOPY+esp]
		jnz			radius1_loopY_start
		jmp			exit

;######################################################################################
radius3:
;######################################################################################
align 16
radius3_loopY_start:
		mov			eax,[width$+esp]
		sub			eax,6				;subtract both left and right 3 pixels
		shr			eax,1				;loopX / 2
		mov			[LOOPX+esp],eax

align 16
radius3_loopX_start:

;*****************************
;* case X=0                  *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2low
		mov			[START_Y+esp],eax		;START_Y = Current

		mov			ebx,[radiusY$+esp]		;
		mov			edi,ebx
		shl			edi,1
		mov			eax,[Y+esp]
		mov			edx,eax
		mov			esi,eax
		and			esi,00000001y
		mov			ecx,[multfact$+esp]
		shr			ecx,1
		cmovnz		ebx,edi					;if(_multifact==2) radiusY<<=1
		sub			eax,ebx					;y-radiusY
		cmovs		eax,esi					;lowy=y-radiusY,if(y-radiusY<0),then (y&1)
		mov			esi,eax					;lowy
		mov			eax,[height$+esp]		;hight-1
		mov			edi,eax
		mov			ecx,edx					;y
		add			ecx,ebx					;y+radiusy
		sub			eax,ecx					;(hight-1)-(y+radiusy)
		cmovb		ecx,edi					;highy=y+radiusy, if(y+radiusY>hight-1),then hight-1			
		sub			ecx,esi					;
		mov			eax,ecx
		shr			eax,1
		mov			edi,[multfact$+esp]
		shr			edi,1
		cmovnz		ecx,eax					;if(multifact==2) count/2
		inc			ecx						;loopY counter=highY-lowY+1
		mov			[LINENUMS+esp],ecx
		mov			eax,esi
		sub			eax,edx					;lowy-y
		mov			ebx,eax
		shr			ebx,1
		or			edi,edi					;if (multfact/2==0) (lowy-y)/2
		cmovnz		eax,ebx
		mul			DWORD PTR [pitchm$+esp]
		add			[START_Y+esp],eax

		mov			eax,ecx					;toalnums = loopY counter * 4
		shl			eax,2
		mov			[TOTALNUMS+esp],eax
		
		mov			eax,[START_Y+esp]
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)

align 16
radius3_0_loop:
		movq		mm0,[eax]			;(current+0),(current+1)
		m_cmp_low_high
		movq		mm0,[eax+8]			;(current+2),(current+3)
		m_cmp_low_high
		dec			ecx
		jle			radius3_0_store_data
		add			eax,esi
		jmp			radius3_0_loop

radius3_0_store_data:
		m_store_data_even

;*****************************
;* case X=1                  *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2high

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		add			eax,ecx
		mov			[TOTALNUMS+esp],eax	;total=counterY * 5
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius3_1_loop:
		movq		mm0,[eax]		;(current-1),(current+0)
		m_cmp_low_high
		movq		mm0,[eax+8]		;(current+1),(current+2)
		m_cmp_low_high
		movq		mm0,[eax+16]		;(current+3)
		m_cmp_low
		dec			ecx
		jle			radius3_1_store_data
		add			eax,esi
		jmp			radius3_1_loop

radius3_1_store_data:
		m_store_data_odd

;*****************************
;* case X=2                  *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)
		m_get_yuy2low

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		add			eax,ecx
		add			eax,ecx
		mov			[TOTALNUMS+esp],eax	;total=counterY*6
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius3_2_loop:
		movq		mm0,[eax-8]			;(current-2),(current-1)
		m_cmp_low_high
		movq		mm0,[eax+0]			;(current+0),(current+1)
		m_cmp_low_high
		movq		mm0,[eax+8]			;(current+2),(current+3)
		m_cmp_low_high
		dec			ecx
		jle			radius3_2_store_data
		add			eax,esi
		jmp			radius3_2_loop

radius3_2_store_data:
		m_store_data_even

;*****************************
;* case X=3 to width-4       *
;*****************************

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,3
		sub			eax,ecx				;total=loopY*7
		mov			[TOTALNUMS+esp],eax

align 16
radius3_full_loopX:

;+++++++++ odd +++++++
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)
		m_get_yuy2high

		xor			edx,edx				;counter = 0
		mov			ecx,[LINENUMS+esp]
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius3_full_high_loop1_odd:
		movq		mm0,[eax-8]		;pixel_X=(currentX-3),(currentX-2)
		m_cmp_low_high
		movq		mm0,[eax+0]		;pixel_X=(currentX-1),(currentX+0)
		m_cmp_low_high
		movq		mm0,[eax+8]		;pixel_X=(currentX+1),(currentX+2)
		m_cmp_low_high
		movq		mm0,[eax+16]		;pixel_X=(currentX+3)
		m_cmp_low
		dec			ecx
		jle			radius3_make_store_data_odd
		add			eax,esi
		jmp			radius3_full_high_loop1_odd
	
radius3_make_store_data_odd:
		prefetchnta	[eax+16]
		m_store_data_odd


;+++++++++ even +++++++
		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2low

		xor			edx,edx				;counter = 0
		mov			ecx,[LINENUMS+esp]
		mov			eax,[START_Y+esp]	;
		mov			esi,[pitchm$+esp]

align 16
radius3_full_low_loop1_even:
		movq		mm0,[eax-16]		;pixel_X=(currentX-3)
		m_cmp_high
		movq		mm0,[eax-8]		;pixel_X=(currentX-2),(currentX-1)
		m_cmp_low_high
		movq		mm0,[eax+0]		;pixel_X=(currentX+0),(currentX+1)
		m_cmp_low_high
		movq		mm0,[eax+8]		;pixel_X=(currentX+2),(currentX+3)
		m_cmp_low_high
		dec			ecx
		jle			radius3_make_store_data_even
		add			eax,esi
		jmp			radius3_full_low_loop1_even

radius3_make_store_data_even:
		prefetchnta	[eax+16]
		m_store_data_even

		dec			DWORD PTR [LOOPX+esp]
		jnz			radius3_full_loopX

;*****************************
;* case X = width-3          *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2high

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		add			eax,ecx
		add			eax,ecx
		mov			[TOTALNUMS+esp],eax	;total = loopY count * 6
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius3_w3_border:
		movq		mm0,[eax-8]			;(current-3),(current-2)
		m_cmp_low_high
		movq		mm0,[eax+0]			;(current-1),(current+0)
		m_cmp_low_high
		movq		mm0,[eax+8]			;(current+1),(current+2)
		m_cmp_low_high
		dec			ecx
		jle			radius3_w3_store_data
		add			eax,esi
		jmp			radius3_w3_border

radius3_w3_store_data:
		m_store_data_odd

;*****************************
;* case X = width-2          *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2low

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		add			eax,ecx
		mov			[TOTALNUMS+esp],eax	;total = loopY count * 5
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius3_w2_border:
		movq		mm0,[eax-16]		;(current-3)
		m_cmp_high
		movq		mm0,[eax-8]		;(current-2),(current-1)
		m_cmp_low_high
		movq		mm0,[eax]		;(current+0),(current+1)
		m_cmp_low_high
		dec			ecx
		jle			radius3_w2_store_data
		add			eax,esi
		jmp			radius3_w2_border

radius3_w2_store_data:
		m_store_data_even

;*****************************
;* case X = width-1          *
;*****************************

		movq		mm5,mm7			;counter clear(numbers of data within threshold limit)

		m_get_yuy2high

		mov			ecx,[LINENUMS+esp]
		mov			eax,ecx
		shl			eax,2
		mov			[TOTALNUMS+esp],eax	;total = loopY count * 4
		mov			esi,[pitchm$+esp]
		xor			edx,edx				;counter clear(within limit pixels)
		mov			eax,[START_Y+esp]
		
align 16
radius3_w1_border:
		movq		mm0,[eax-8]			;(current-3),(current-2)
		m_cmp_low_high
		movq		mm0,[eax+0]			;(current-1),(current)
		m_cmp_low_high
		dec			ecx
		jle			radius3_w1_store_data
		add			eax,esi
		jmp			radius3_w1_border

radius3_w1_store_data:
		m_store_data_odd

		mov			edi,[dst_modulo$+esp]
		add			[dstp$+esp],edi

;*****************************
;* while end loopY           *
;*****************************
radius3_loopY_end:

		inc			DWORD PTR [Y+esp]
		dec			DWORD PTR [LOOPY+esp]
		jnz			radius3_loopY_start
		jmp			exit

;=================================================================================
;=================================================================================

ppixels@60 ENDP
_TEXT64 ENDS
END


